package com.steerinfo.dil.controller;
import com.steerinfo.dil.feign.RmsFeign;
import com.steerinfo.framework.controller.RESTfulResult;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;
@RestController
@RequestMapping("${api.version}/rms")
public class RMScontroller {
    @Autowired
    RmsFeign rmsFeign;
    @ApiOperation(value="展示司机信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(218)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getCarDriverList")
    public Map<String, Object> getCarDriverList(@RequestBody(required=false) Map<String,Object> mapValue,
                                            Integer apiId,
                                            Integer pageNum,
                                            Integer pageSize
    ){
        return   rmsFeign.getCarDriverList(mapValue == null ? new HashMap<>() : mapValue, apiId, pageNum, pageSize);
    }
    @ApiOperation(value="创建", notes="根据RmsCarDriver对象创建")
    @ApiImplicitParam(name = "rmsCarDriver", value = "详细实体rmsCarDriver", required = true, dataType = "RmsCarDriver")
    //@RequiresPermissions("rmscardriver:create")
    @PostMapping(value = "/insertCarDriver")
    public Map<String, Object> insertCarDriver(@RequestBody(required = false) Map<String, Object> map){
        return rmsFeign.insertCarDriver(map);
    }

//    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的rmsCarDriver信息来更新详细信息")
//    @ApiImplicitParams({
//            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal"),
//            @ApiImplicitParam(name = "rmsCarDriver", value = "详细实体rmsCarDriver", required = true, dataType = "RmsCarDriver")
//    })
//    @PostMapping(value = "/updateCarDriver/{id}")
//    RESTfulResult updateCarDriver(@PathVariable("id") String id) {
//        return rmsFeign.updateCarDriver(id);
//    }
    @ApiOperation(value="删除司机信息", notes="根据url的id来指定更新对象，并根据传过来的rmsCarDriver信息删除司机信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "BigDecimal"),
            @ApiImplicitParam(name = "rmsCarDriver", value = "详细实体rmsCarDriver", required = true, dataType = "RmsCarDriver")
    })
    @PostMapping(value = "/deleteCarDriver/{id}")
    Map<String, Object> deleteCarDriver(@PathVariable("id") BigDecimal id) {
        return rmsFeign.deleteCarDriver(id);
    }
    //获取承运商列表
    @ApiOperation(value="获取承运商列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId()", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })

    @PostMapping("/getCarrierList")
    public Map<String, Object> getCarrierList(@RequestBody(required=false) Map<String,Object> mapValue,
                                                Integer apiId,
                                                Integer pageNum,
                                                Integer pageSize
    ){
        return   rmsFeign.getCarrierList(mapValue == null ? new HashMap<>() : mapValue, apiId, pageNum, pageSize);
    }
    @ApiOperation(value="新建承运商", notes="根据rmsCarrier对象创建")
    @ApiImplicitParam(name = "rmsCarrier", value = "详细实体rmsCarrier", required = true, dataType = "rmsCarrier")
    @PostMapping(value = "/insertCarrier")
    public Map<String, Object> insertCarrier(@RequestBody(required = false) Map<String, Object> map){
        return rmsFeign.insertCarrier(map);
    }
    @ApiOperation(value="删除", notes="根据rmsCarrier对象创建")
    @ApiImplicitParam(name = "rmsCarrier", value = "详细实体rmsCarrier", required = true, dataType = "rmsCarrier")
    @PostMapping(value = "/deleteCarrier/{id}")
    public Map<String, Object> deleteCarrier(@PathVariable("id")BigDecimal id){
        return rmsFeign.deleteCarrier(id);
    }
    //获取物资列表
    @ApiOperation(value="获取物资列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId()", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })

    @PostMapping("/getMaterialList")
    public Map<String, Object> getMaterialList(@RequestBody(required=false) Map<String,Object> mapValue,
                                              Integer apiId,
                                              Integer pageNum,
                                              Integer pageSize
    ){
        return   rmsFeign.getMaterialList(mapValue == null ? new HashMap<>() : mapValue, apiId, pageNum, pageSize);
    }
    @ApiOperation(value="新增物资", notes="根据rmsMaterial对象创建")
    @ApiImplicitParam(name = "rmsMaterial", value = "详细实体rmsMaterial", required = true, dataType = "rmsMaterial")
    @PostMapping(value = "/insertMaterial")
    public Map<String, Object> insertMaterial(@RequestBody(required = false) Map<String, Object> map){
        return rmsFeign.insertMaterial(map);
    }
    @ApiOperation(value="删除", notes="根据rmsCarrier对象创建")
    @ApiImplicitParam(name = "rmsMaterial", value = "详细实体rmsMaterial", required = true, dataType = "rmsMaterial")
    @PostMapping(value = "/deleteMaterial/{id}")
    public Map<String, Object> deleteMaterial(@PathVariable("id")BigDecimal id){
        return rmsFeign.deleteMaterial(id);
    }
    @ApiOperation(value="获取人员信息列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId()", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })

    @PostMapping("/getPersonnelList")
    public Map<String, Object> getPersonnelList(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize
    ){
        return   rmsFeign.getPersonnelList(mapValue == null ? new HashMap<>() : mapValue, apiId, pageNum, pageSize);
    }
    @ApiOperation(value="新增人员信息", notes="根据rmsMaterial对象创建")
    @ApiImplicitParam(name = "rmsPersonnel", value = "详细实体rmsPersonnel", required = true, dataType = "rmsPersonnel")
    @PostMapping(value = "/insertPersonnel")
    public Map<String, Object> insertPersonnel(@RequestBody(required = false) Map<String, Object> map){
        return rmsFeign.insertPersonnel(map);
    }
    @ApiOperation(value="删除", notes="根据rmsCarrier对象创建")
    @ApiImplicitParam(name = "rmsMaterial", value = "详细实体rmsPersonnel", required = true, dataType = "rmsPersonnel")
    @PostMapping(value = "/deletePersonnel/{id}")
    public Map<String, Object> deletePersonnel(@PathVariable("id")BigDecimal id){
        return rmsFeign.deletePersonnel(id);
    }
    @ApiOperation(value="获取承运商列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId()", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })

    @PostMapping("/getShipperList")
    public Map<String, Object> getShipperList(@RequestBody(required=false) Map<String,Object> mapValue,
                                                Integer apiId,
                                                Integer pageNum,
                                                Integer pageSize
    ){
        return   rmsFeign.getShipperList(mapValue == null ? new HashMap<>() : mapValue, apiId, pageNum, pageSize);
    }
    @ApiOperation(value="新增人员信息", notes="根据rmsShipper对象创建")
    @ApiImplicitParam(name = "rmsShipper", value = "详细实体rmsShipper", required = true, dataType = "rmsShipper")
    @PostMapping(value = "/insertShipper")
    public Map<String, Object> insertShipper(@RequestBody(required = false) Map<String, Object> map){
        return rmsFeign.insertShipper(map);
    }
    @ApiOperation(value="删除", notes="根据rmsCarrier对象创建")
    @ApiImplicitParam(name = "承运商id", value = "id", required = true, dataType = "int")
    @PostMapping(value = "/deleteShipper/{id}")
    public Map<String, Object> deleteShipper(@PathVariable("id")BigDecimal id){
        return rmsFeign.deleteShipper(id);
    }
    @ApiOperation(value="展示供应商信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId()", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })

    @PostMapping("/getSupplierList")
    public Map<String, Object> getSupplierList(@RequestBody(required=false) Map<String,Object> mapValue,
                                              Integer apiId,
                                              Integer pageNum,
                                              Integer pageSize
    ){
        return   rmsFeign.getSupplierList(mapValue == null ? new HashMap<>() : mapValue, apiId, pageNum, pageSize);
    }
    @ApiOperation(value="新增供应商信息", notes="根据rmsShipper对象创建")
    @ApiImplicitParam(name = "rmsSupplier", value = "详细实体rmsSupplier", required = true, dataType = "rmsSupplier")
    @PostMapping(value = "/insertSupplier")
    public Map<String, Object> insertSupplier(@RequestBody(required = false) Map<String, Object> map){
        return rmsFeign.insertSupplier(map);
    }
    @ApiOperation(value="删除", notes="根据rmsCarrier对象创建")
    @ApiImplicitParam(name = "承运商id", value = "id", required = true, dataType = "int")
    @PostMapping(value = "/deleteSupplier/{id}")
    public Map<String, Object> deleteSupplier(@PathVariable("id")BigDecimal id){
        return rmsFeign.deleteSupplier(id);
    }
    @ApiOperation(value="展示运力信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(219)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })

    @PostMapping("/getCapacityList")
    public Map<String, Object> getCapacityList(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize
    ){
        return   rmsFeign.getCapacityList(mapValue == null ? new HashMap<>() : mapValue, apiId, pageNum, pageSize);
    }
    @ApiOperation(value="新增运力信息", notes="根据rmsCapacity对象创建")
    @ApiImplicitParam(name = "rmsCapacity", value = "详细实体rmsCapacity", required = true, dataType = "rmsCapacity")
    @PostMapping(value = "/insertCapacity")
    public Map<String, Object> insertCapacity(@RequestBody(required = false) Map<String, Object> map){
        return rmsFeign.insertCapacity(map);
    }
    @ApiOperation(value="删除", notes="根据rmsCarrier对象创建")
    @ApiImplicitParam(name = "运力id", value = "id", required = true, dataType = "int")
    @PostMapping(value = "/deleteCapacity/{id}")
    public Map<String, Object> deleteCapacity(@PathVariable("id")BigDecimal id){
        return rmsFeign.deleteCapacity(id);
    }
    @ApiOperation(value="展示汽车衡列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId()", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getTruckCalculateList")
    public Map<String, Object> getTruckCalculateList(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize
    ){
        return   rmsFeign.getTruckCalculateList(mapValue == null ? new HashMap<>() : mapValue, apiId, pageNum, pageSize);
    }
    @ApiOperation(value="新增汽车衡信息", notes="根据rmsCapacity对象创建")
    @ApiImplicitParam(name = "rmsTruckCalculate", value = "详细实体rmsTruckCalculate", required = true, dataType = "rmsTruckCalculate")
    @PostMapping(value = "/insertTruckCalculate")
    public Map<String, Object> insertTruckCalculate(@RequestBody(required = false) Map<String, Object> map){
        return rmsFeign.insertTruckCalculate(map);
    }
    @ApiOperation(value="删除", notes="根据rmsCarrier对象创建")
    @ApiImplicitParam(name = "汽车衡id", value = "id", required = true, dataType = "int")
    @PostMapping(value = "/deleteTruckCalculate/{id}")
    public Map<String, Object> deleteTruckCalculate(@PathVariable("id")BigDecimal id){
        return rmsFeign.deleteTruckCalculate(id);
    }
    @ApiOperation(value="展示原料信息", notes="分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "apiId", value = "196", required = false, dataType = "BigDecimal"),
    })
    @PostMapping(value = "/getWarehouseList")
    public Map<String, Object> getWarehouseList(@RequestBody(required=false) Map<String,Object> mapValue,
                                                     Integer apiId,
                                                     Integer pageNum,
                                                     Integer pageSize
    ){
        return   rmsFeign.getWarehouseList(mapValue == null ? new HashMap<>() : mapValue, apiId, pageNum, pageSize);
    }
    @ApiOperation(value="新增汽车衡信息", notes="根据rmsWarehouse对象创建")
    @ApiImplicitParam(name = "rmsWarehouse", value = "详细实体rmsWarehouse", required = true, dataType = "rmsWarehouse")
    @PostMapping(value = "/insertWarehouse")
    public Map<String, Object> insertWarehouse(@RequestBody(required = false) Map<String, Object> map){
        return rmsFeign.insertWarehouse(map);
    }
    @ApiOperation(value="删除", notes="根据rmsCarrier对象创建")
    @ApiImplicitParam(name = "仓库id", value = "id", required = true, dataType = "int")
    @PostMapping(value = "/deleteWarehouse/{id}")
    public Map<String, Object> deleteWarehouse(@PathVariable("id")BigDecimal id){
        return rmsFeign.deleteWarehouse(id);
    }
    //*******************************下拉框************************
    @GetMapping("getCapacityId")
    @ApiOperation(value = "得到下拉运力id")
    public Map<String, Object> getCapacityId() {
        return rmsFeign.getCapacityId();
    }

    /**
     * @author huk
     * @return
     */
    //查询所有作业环节
    @ApiOperation(value="查询所有作业环节")
    @PostMapping("/getLink")
    public Map<String, Object> getlink(){
        return  rmsFeign.getlink();
    }

    /**
     * @author huk
     * @return
     */
    //新增运输路线
    @ApiOperation(value="新增运输路线")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "运输路线", required = false, dataType = "Map"),
    })
    @PostMapping("/insertSelective")
    public Map<String, Object> insertSelective(@RequestBody(required = false) Map<String,Object> mapVal){
        return rmsFeign.insertSelective(mapVal);
    }


    @ApiOperation(value="查询运输路线")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId", value = "249", required = false, dataType = "Integer"),
    })
    @PostMapping(value = "/getAllLineDesk")
    public Map<String, Object> getAllLineDesk(@RequestBody(required = false) Map<String,Object> mapValue,
                                        Integer pageNum,
                                        Integer pageSize,
                                        Integer apiId,
                                        String con){
        return rmsFeign.getAllLineDesk(mapValue==null?new HashMap<>():mapValue, pageNum, pageSize, apiId, con);
    }

    @ApiOperation(value = "根据主键查询出数据以供修改")
    @PostMapping("/getLinkToUpdate")
    public Map<String, Object> getLinkToUpdate(@RequestParam Integer lineId) {
        return rmsFeign.getLinkToUpdate(lineId);
    }

    @ApiOperation(value = "根据运输线路主表ID修改数据")
    @PostMapping("/updateByPrimaryKeySelective")
    public Map<String, Object> updateByPrimaryKeySelective(@RequestBody(required = false) Map<String,Object> mapVal) {
        return rmsFeign.updateByPrimaryKeySelective(mapVal);
    }

    @ApiOperation(value = "根据运输线路主表ID修改数据,为逻辑删除")
    @PostMapping("/updateRmsLine")
    Map<String, Object> updateRmsLine(@RequestBody(required = false) Map<String,Object> mapVal){
        return  rmsFeign.updateRmsLine(mapVal);
    }
}
