package com.steerinfo.dil.feign;
import com.steerinfo.framework.controller.RESTfulResult;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Map;

@FeignClient(value = "DIL-RMS-API-DEV", url = "${openfeign.RmsFeign.url}")
public interface RmsFeign {
    //展示司机信息
    @PostMapping(value = "api/v1/rms/rmscardriver/getCarDriverList")
    Map<String,Object> getCarDriverList  (@RequestBody(required = false) Map<String, Object> mapValue,
                                          @RequestParam("apiId") Integer apiId,
                                           @RequestParam("pageNum") Integer pageNum,
                                           @RequestParam("pageSize") Integer pageSize

                                           );
    //新增司机信息
    @PostMapping(value = "api/v1/rms/rmscardriver/insertCarDriver")
    Map<String, Object> insertCarDriver(@RequestBody(required = false) Map<String, Object> map);
    //删除司机信息
    @PostMapping(value = "api/v1/rms/rmscardriver/deleteCarDriver/{id}")
    Map<String, Object> deleteCarDriver(@PathVariable("id") BigDecimal id);
    //获取托运人列表
    @PostMapping(value = "api/v1/rms/rmscarriers/getCarrierList")
    Map<String,Object>     getCarrierList(@RequestBody(required = false) Map<String, Object> mapValue,
                                          @RequestParam("apiId") Integer apiId,
                                          @RequestParam("pageNum") Integer pageNum,
                                          @RequestParam("pageSize") Integer pageSize

    );
    //新增托运人
    @PostMapping(value = "api/v1/rms/rmscardriver/insertCarrier")
    Map<String, Object> insertCarrier(@RequestBody(required = false) Map<String, Object> map);
    //删除托运人
    @PostMapping(value = "api/v1/rms/rmscardriver/deleteCarrier/{id}")
    Map<String, Object> deleteCarrier(@PathVariable("id") BigDecimal id);
    //获取物资列表
    @PostMapping(value = "api/v1/rms/rmsmaterial/getMaterialList")
    Map<String,Object>     getMaterialList(@RequestBody(required = false) Map<String, Object> mapValue,
                                           @RequestParam("apiId") Integer apiId,
                                          @RequestParam("pageNum") Integer pageNum,
                                          @RequestParam("pageSize") Integer pageSize

    );
    //新增物资
    @PostMapping(value = "api/v1/rms/rmsmaterial/insertMaterial")
    Map<String, Object> insertMaterial(@RequestBody(required = false) Map<String, Object> map);
    //删除物资
    @PostMapping(value = "api/v1/rms/rmscardriver/deleteMaterial/{id}")
    Map<String, Object> deleteMaterial(@PathVariable("id") BigDecimal id);
    //获得人员列表
    @PostMapping(value = "api/v1/rms/rmspersonnel/getPersonnelList")
    Map<String,Object>   getPersonnelList(@RequestBody(required = false) Map<String, Object> mapValue,
                                          @RequestParam("apiId") Integer apiId,
                                          @RequestParam("pageNum") Integer pageNum,
                                          @RequestParam("pageSize") Integer pageSize

    );
    @PostMapping(value = "api/v1/rms/rmspersonnel/insertPersonnel")
    Map<String, Object> insertPersonnel(@RequestBody(required = false) Map<String, Object> map);
    //删除人员信息
    @PostMapping(value = "api/v1/rms/rmspersonnel/deletePersonnel/{id}")
    Map<String, Object> deletePersonnel(@PathVariable("id") BigDecimal id);
    //获得承运商列表
    @PostMapping(value = "api/v1/rms/rmsshippers/getShipperList")
    Map<String,Object>   getShipperList (@RequestBody(required = false) Map<String, Object> mapValue,
                                         @RequestParam("apiId") Integer apiId,
                                          @RequestParam("pageNum") Integer pageNum,
                                          @RequestParam("pageSize") Integer pageSize

    );
    //新增承运商信息
    @PostMapping(value = "api/v1/rms/rmsshippers/insertShipper")
    Map<String, Object> insertShipper(@RequestBody(required = false) Map<String, Object> map);
    //删除承运商
    @PostMapping(value = "api/v1/rms/rmsshippers/deleteShipper/{id}")
    Map<String, Object> deleteShipper(@PathVariable("id") BigDecimal id);
    //展示供应商列表
    @PostMapping(value = "api/v1/rms/rmssupplier/getSupplierList")
    Map<String,Object>   getSupplierList (@RequestBody(required = false) Map<String, Object> mapValue,
                                          @RequestParam("apiId") Integer apiId,
                                          @RequestParam("pageNum") Integer pageNum,
                                          @RequestParam("pageSize") Integer pageSize

    );
    //新增供应商信息
    @PostMapping(value = "api/v1/rms/rmsshippers/insertSupplier")
    Map<String, Object> insertSupplier(@RequestBody(required = false) Map<String, Object> map);
    //删除承运商
    @PostMapping(value = "api/v1/rms/rmsshippers/deleteSupplier/{id}")
    Map<String, Object> deleteSupplier(@PathVariable("id") BigDecimal id);
    @PostMapping(value = "api/v1/rms/rmscapacity/getCapacityList")
    Map<String,Object>   getCapacityList (@RequestBody(required = false) Map<String, Object> mapValue,
                                          @RequestParam("apiId") Integer apiId,
                                          @RequestParam("pageNum") Integer pageNum,
                                          @RequestParam("pageSize") Integer pageSize

    );
    //新增运力
    @PostMapping(value = "api/v1/rms/rmscapacity/insertCapacity")
    Map<String, Object> insertCapacity(@RequestBody(required = false) Map<String, Object> map);
    //删除运力
    @PostMapping(value = "api/v1/rms/rmscapacity/deleteCapacity/{id}")
    Map<String, Object> deleteCapacity(@PathVariable("id") BigDecimal id);
    //查找汽车衡列表
    @PostMapping(value = "api/v1/rms/rmstruckcalculate/getTruckCalculateList")
    Map<String,Object>   getTruckCalculateList (@RequestBody(required = false) Map<String, Object> mapValue,
                                                @RequestParam("apiId") Integer apiId,
                                                @RequestParam("pageNum") Integer pageNum,
                                                @RequestParam("pageSize") Integer pageSize
    );
    //新增汽车衡
    @PostMapping(value = "api/v1/rms/rmstruckcalculate/insertTruckCalculate")
    Map<String, Object> insertTruckCalculate(@RequestBody(required = false) Map<String, Object> map);
    //根据id删除汽车衡
    @PostMapping(value = "api/v1/rms/rmstruckcalculate/deleteTruckCalculate/{id}")
    Map<String, Object> deleteTruckCalculate(@PathVariable("id") BigDecimal id);

    @PostMapping(value = "api/v1/rms/rmswarehouse/getWarehouseList")
    Map<String,Object>   getWarehouseList (@RequestBody(required = false) Map<String, Object> mapValue,
                                           @RequestParam("apiId") Integer apiId,
                                           @RequestParam("pageNum") Integer pageNum,
                                           @RequestParam("pageSize") Integer pageSize
    );
    //新增仓库
    @PostMapping(value = "api/v1/rms/rmswarehouse/insertWarehouse")
    Map<String, Object> insertWarehouse(@RequestBody(required = false) Map<String, Object> map);
    //删除仓库
    @PostMapping(value = "api/v1/rms/rmswarehouse/deleteWarehouse/{id}")
    Map<String, Object> deleteWarehouse(@PathVariable("id") BigDecimal id);
    //******************************************下拉框*******************************
    @GetMapping(value = "/api/v1/rms/rmscapacity/getCapacityId")
    Map<String, Object> getCapacityId();

    /**
     * @author huk
     * @return
     */
    @PostMapping("/api/v1/rms/rmslinks/getLink")
    Map<String, Object> getlink();

    /**
     * @author huk
     * @return
     */
    //新增运输路线
    @ApiOperation(value="新增运输路线")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "运输路线", required = false, dataType = "Map"),
    })
    @PostMapping("/api/v1/rms/rmslines/insertSelective")
    Map<String, Object> insertSelective(@RequestBody(required = false) Map<String,Object> mapVal);

    @PostMapping(value = "/api/v1/rms/rmslines/getAllLineDesk")
    Map<String, Object> getAllLineDesk(@RequestBody(required = false) Map<String,Object> mapValue,
                                        @RequestParam("pageNum") Integer pageNum,
                                        @RequestParam("pageSize")Integer pageSize,
                                        @RequestParam("apiId")Integer apiId,
                                        @RequestParam("con")String con);

    @ApiOperation(value = "根据主键查询出数据以供修改")
    @PostMapping("/api/v1/rms/rmslines/getLinkToUpdate")
    Map<String, Object> getLinkToUpdate(@RequestParam Integer lineId);

    @ApiOperation(value = "根据运输线路主表ID修改数据")
    @PostMapping("/api/v1/rms/rmslines/updateByPrimaryKeySelective")
    Map<String, Object> updateByPrimaryKeySelective(@RequestBody(required = false) Map<String,Object> mapVal);

    @ApiOperation(value = "根据运输线路主表ID修改数据,为逻辑删除")
    @PostMapping("/api/v1/rms/rmslines/updateRmsLine")
    Map<String, Object> updateRmsLine(@RequestBody(required = false) Map<String,Object> mapVal);
}
